function addQuestion(arrFragen, aussage, antwortIntro, accept, short) {
    const frage = {
        "html": aussage,
        "singlechoice": true,
        "choices": [
            { "html": antwortIntro, "correct": true, "selectalways": true, "type": "text", "accept": accept }
        ]
    };
    if (short)
        frage.choices[0].size = 3;
    arrFragen.push(frage);
}

function addModellQuestion(arrFragen, aussage, correct) {
    const frage = {
        "html": aussage,
        "singlechoice": true,
        "choices": [
            { "html": "Wie sehr sich die Zahl der Käfer auf gleich großen Plättchen unterscheidet" },
            { "html": "Wie viele Käfer pro Zeiteinheit ein Plättchen verlassen" },
            { "html": "Wie sehr ein Plättchen die Bewegung der Käfer verlangsamt" },
            { "html": "Wie viele Käfer sich auf einem Plättchen befinden" },
            { "html": "Wie viele Käfer ein Plättchen insgesamt betreten haben" },
            { "html": "Wie schnell Käfer sich auf diesem Plättchen bewegen können" }
        ]
    };
    frage.choices[correct].correct = true;
    arrFragen.push(frage);
}

function generate(arrFragen, data) {
    const index = Math.floor(Math.random() * data.reduce((prev, { aussage }) => Math.max(prev, aussage.length), 0));
    data.forEach(item => item.aussage[index] && (item.modell ? addModellQuestion(arrFragen, item.aussage[index], item.correct) : addQuestion(arrFragen, item.aussage[index], item.antwortIntro, item.accept, item.short)));
}

function generateU(arrFragen) {
    generate( arrFragen, [
        {
            "aussage": [
                false,
                "Wie bezeichnen wir im Unterricht <em>Spannung</em> noch?"
            ],
            "antwortIntro": "Anderer Fachbegriff für Spannung: ",
            "accept": ["elektrischer Unterschied", "Elektrischer Unterschied", "el. Unterschied", "El. Unterschied"]
        },
        {
            "aussage": [
                false,
                false,
                "Was ist der übliche Fachbegriff für einen <em>elektrischen Unterschied</em>?"
            ],
            "antwortIntro": "Anderer Fachbegriff für elektrischer Unterschied: ",
            "accept": "Spannung"
        },
        {
            "aussage": [
                "Welche gelernte Größe hat typischerweise einen Wert wie <code>1,5 V</code>?",
                false,
                false,
                "Von welcher gelernten Größe ist die Einheit <em>Volt</em>?",
                "Welche gelernte Größe hat das Formelzeichen <code>U</code>?"
            ],
            "antwortIntro": "Fachbegriff für Größe: ",
            "accept": ["elektrischer Unterschied", "Elektrischer Unterschied", "Spannung", "el. Unterschied", "El. Unterschied"]
        },
        {
            "aussage": [
                "Was ist das <em>Formelzeichen</em> der gelernten Größe, die typischerweise einen Wert wie <code>1,5 V</code> hat?",
                "Was ist das <em>Formelzeichen</em> für <em>Spannung</em>?",
                "Was ist das <em>Formelzeichen</em> für einen <em>elektrischen Unterschied</em>?",
                "Was ist das <em>Formelzeichen</em> der gelernten Größe mit der Einheit <em>Volt</em>?",
                false
            ],
            "antwortIntro": "Formelzeichen: ",
            "accept": "U",
            "short": true
        },
        {
            "aussage": [
                "Wie spricht man die <em>Grundeinheit</em> der gelernten Größe aus, die typischerweise einen Wert wie <code>1,5 V</code> hat?",
                "Wie spricht man die <em>Grundeinheit</em> von <em>Spannung</em> aus?",
                "Wie spricht man die <em>Grundeinheit</em> von <em>elektrischen Unterschied</em>en aus?",
                false,
                "Wie spricht man die <em>Grundeinheit</em> der gelernten Größe mit Formelzeichen <code>U</code> aus?"
            ],
            "antwortIntro": "Ausgeschriebener Name der Grundeinheit (ohne Maßzahl): ",
            "accept": "Volt"
        },
        {
            "aussage": [
                false,
                "Was ist die <em>Abkürzung der Grundeinheit</em> bei der Angabe von <em>Spannung</em>en?",
                "Was ist die <em>Abkürzung der Grundeinheit</em> bei der Angabe von <em>elektrischen Unterschied</em>en?",
                "Was ist die <em>Abkürzung</em> der Einheit <em>Volt</em>?",
                "Was ist die <em>Abkürzung der Grundeinheit</em> der gelernten Größe mit Formelzeichen <code>U</code>?"
            ],
            "antwortIntro": "Abkürzung der Grundeinheit: 1 ",
            "accept": "V",
            "short": true
        },
        {
            "aussage": [
                "Was ist im <em>Käfermodell</em> die gelernte Größe, die typischerweise einen Wert wie <code>1,5 V</code> hat?",
                "Was ist <em>Spannung</em> im <em>Käfermodell</em>?",
                "Was ist ein <em>elektrischer Unterschied</em> im <em>Käfermodell</em>?",
                "Was ist im <em>Käfermodell</em> die gelernte Größe mit der Einheit <em>Volt</em>?",
                "Was ist im <em>Käfermodell</em> die gelernte Größe mit Formelzeichen <code>U</code>?"
            ],
            "modell": true,
            "correct": 0
        }
    ]);
}

function generateR(arrFragen) {
    generate( arrFragen, [
        {
            "aussage": [
                false,
                "Wie bezeichnen wir im Unterricht die elektrische Größe <em>Widerstand</em>?"
            ],
            "antwortIntro": "Anderer Fachbegriff für Widerstand: ",
            "accept": ["elektrische Retardation", "Elektrische Retardation", "el. Retardation", "El. Retardation", "Retardation", "elektrische Verlangsammung", "Elektrische Verlangsammung", "el. Verlangsammung", "El. Verlangsammung", "Verlangsammung", "elektrische Bremsung", "Elektrische Bremsung", "el. Bremsung", "El. Bremsung", "Bremsung"]
        },
        {
            "aussage": [
                false,
                false,
                "Was ist der übliche Fachbegriff für <em>elektrische Retardation</em>?"
            ],
            "antwortIntro": "Anderer Fachbegriff für elektrische Retardation: ",
            "accept": "Widerstand"
        },
        {
            "aussage": [
                "Welche gelernte Größe hat typischerweise einen Wert wie <code>330 Ω</code>?",
                false,
                false,
                "Von welcher gelernten Größe ist die Einheit <em>Ohm</em>?",
                "Welche gelernte Größe hat das Formelzeichen <code>R</code>?"
            ],
            "antwortIntro": "Fachbegriff für Größe: ",
            "accept": ["elektrische Retardation", "Elektrische Retardation", "el. Retardation", "El. Retardation", "Retardation", "elektrische Verlangsammung", "Elektrische Verlangsammung", "el. Verlangsammung", "El. Verlangsammung", "Verlangsammung", "elektrische Bremsung", "Elektrische Bremsung", "el. Bremsung", "El. Bremsung", "Bremsung", "Widerstand"]
        },
        {
            "aussage": [
                "Was ist das <em>Formelzeichen</em> der gelernten Größe, die typischerweise einen Wert wie <code>330 Ω</code> hat?",
                "Was ist das <em>Formelzeichen</em> für <em>Widerstand</em>?",
                "Was ist das <em>Formelzeichen</em> für einen <em>elektrische Retardation</em>?",
                "Was ist das <em>Formelzeichen</em> der gelernten Größe mit der Einheit <em>Ohm</em>?",
                false
            ],
            "antwortIntro": "Formelzeichen: ",
            "accept": "R",
            "short": true
        },
        {
            "aussage": [
                "Wie spricht man die <em>Grundeinheit</em> der gelernten Größe aus, die typischerweise einen Wert wie <code>330 Ω</code> hat?",
                "Wie spricht man die <em>Grundeinheit</em> von <em>Widerstand</em> aus?",
                "Wie spricht man die <em>Grundeinheit</em> von <em>elektrische Retardation</em>en aus?",
                false,
                "Wie spricht man die <em>Grundeinheit</em> der gelernten Größe mit Formelzeichen <code>R</code> aus?"
            ],
            "antwortIntro": "Ausgeschriebener Name der Grundeinheit (ohne Maßzahl): ",
            "accept": "Ohm"
        },
        {
            "aussage": [
                "Was ist im <em>Käfermodell</em> die gelernte Größe, die typischerweise einen Wert wie <code>330 Ω</code> hat?",
                "Was ist die Größe <em>Widerstand</em> im <em>Käfermodell</em>?",
                "Was ist <em>elektrische Retardation</em> im <em>Käfermodell</em>?",
                "Was ist im <em>Käfermodell</em> die gelernte Größe mit der Einheit <em>Ohm</em>?",
                "Was ist im <em>Käfermodell</em> die gelernte Größe mit Formelzeichen <code>R</code>?"
            ],
            "modell": true,
            "correct": 2
        }
    ]);
}

function generateI(arrFragen) {
    generate( arrFragen, [
        {
            "aussage": [
                false,
                "Wie bezeichnen wir im Unterricht <em>Stromstärke</em>?"
            ],
            "antwortIntro": "Anderer Fachbegriff für „Stromstärke“: ",
            "accept": ["elektrische Intensität", "Elektrische Intensität", "el. Intensität", "El. Intensität", "Intensität"]
        },
        {
            "aussage": [
                false,
                false,
                "Was ist der übliche Fachbegriff für <em>elektrische Intensität</em>?"
            ],
            "antwortIntro": "Anderer Fachbegriff für elektrische Intensität: ",
            "accept": "Stromstärke"
        },
        {
            "aussage": [
                "Welche gelernte Größe hat typischerweise einen Wert wie <code>20 mA</code>?",
                false,
                false,
                "Von welcher gelernten Größe ist die Einheit <em>Ampere</em>?",
                "Welche gelernte Größe hat das Formelzeichen <code>I</code>?"
            ],
            "antwortIntro": "Fachbegriff für Größe: ",
            "accept": ["elektrische Intensität", "Elektrische Intensität", "Stromstärke", "el. Intensität", "El. Intensität"]
        },
        {
            "aussage": [
                "Was ist das <em>Formelzeichen</em> der gelernten Größe, die typischerweise einen Wert wie <code>20 mA</code> hat?",
                "Was ist das <em>Formelzeichen</em> für <em>Stromstärke</em>?",
                "Was ist das <em>Formelzeichen</em> für eine <em>elektrische Intensität</em>?",
                "Was ist das <em>Formelzeichen</em> der gelernten Größe mit der Einheit <em>Ampere</em>?",
                false
            ],
            "antwortIntro": "Formelzeichen: ",
            "accept": "I",
            "short": true
        },
        {
            "aussage": [
                "Wie spricht man die <em>Grundeinheit</em> der gelernten Größe aus, die typischerweise einen Wert wie <code>20 mA</code> hat?",
                "Wie spricht man die <em>Grundeinheit</em> von <em>Stromstärke</em> aus?",
                "Wie spricht man die <em>Grundeinheit</em> von <em>elektrische Intensität</em>en aus?",
                false,
                "Wie spricht man die <em>Grundeinheit</em> der gelernten Größe mit Formelzeichen <code>I</code> aus?"
            ],
            "antwortIntro": "Ausgeschriebener Name der Grundeinheit (ohne Maßzahl): ",
            "accept": ["Ampere", "Ampère", "Amper"]
        },
        {
            "aussage": [
                false,
                "Was ist die <em>Abkürzung der Grundeinheit</em> bei der Angabe von <em>Stromstärke</em>en?",
                "Was ist die <em>Abkürzung der Grundeinheit</em> bei der Angabe von <em>elektrischer Intensität</em>en?",
                "Was ist die <em>Abkürzung</em> der Einheit <em>Ampere</em>?",
                "Was ist die <em>Abkürzung der Grundeinheit</em> der gelernten Größe mit Formelzeichen <code>I</code>?"
            ],
            "antwortIntro": "Abkürzung der Grundeinheit: 1 ",
            "accept": "A",
            "short": true
        },
        {
            "aussage": [
                "Was ist im <em>Käfermodell</em> die gelernte Größe, die typischerweise einen Wert wie <code>20 mA</code> hat?",
                "Was ist <em>Stromstärke</em> im <em>Käfermodell</em>?",
                "Was ist ein <em>elektrische Intensität</em> im <em>Käfermodell</em>?",
                "Was ist im <em>Käfermodell</em> die gelernte Größe mit der Einheit <em>Ampere</em>?",
                "Was ist im <em>Käfermodell</em> die gelernte Größe mit Formelzeichen <code>I</code>?"
            ],
            "modell": true,
            "correct": 1
        }
    ]);
}

window.MultipleChoiceTestData = {
    // Optional: Wie viele Versuche hat der/die Lernende (Standardwert: Unendlich)
    "maxTries": Infinity,

    // Optional: Soll statt der Anzahl an nötigen Versuchen bewertet werden, wie gut der/die Lernende abschneidet?
    "reportScore": false,

    // Optional: Sollen die Fragen nicht durchgemischt werden?
    "keepOrder": false,

    // Optional: Wie soll bewertet werden?
    // "questions"  → Standardwert, Frage kann entweder richtig sein (1 von 1 Punkt) oder falsch (0 von 1 Punkt)
    // "average"    → Durchschnittlicher Prozentsatz an richtig ausgewählten bzw. richtig nicht ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten bei jeder Frage
    // "choices"    → Anteil der richtig ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten
    "countMode": "questions",

    // Wie viele Fragen sollen für einen Test gezogen werden?
    "questionsPerTest": 6,

    // Welcher Anteil muss mindestens richtig sein, um zu bestehen?
    "threshold": 1,

    // Optional: Begrüßungstext
    "htmlIntro": "<p>Beantworte alle Fragen richtig:</p>",

    // Verfügbare Fragen
    "questions": [
    ],

    // Fragengeneratoren
    "generators": [
        generateU,
        generateI,
        generateR
    ]
}
